-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["WARRIOR"] = {}
lib.classes["WARRIOR"][2] = function ()

	cfg.spells={}
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("strike",{88161}) -- Strike
	lib.AddSpell("bt",{23881}) -- Bloodthirst
	lib.AddSpell("rb",{85288}) -- Raging Blow	
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("dw",{12292}) -- Death Wish
	lib.AddSpell("hs",{78}) -- Heroic Strike
	
	lib.AddSpell("ir",{1134}) -- Inner Rage
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ww",{1680}) -- Whirlwind
	
				
	cfg.auras={}
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"debuff","target") -- Executioner
	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	lib.AddAura("Incite",86627,"buff","player") -- Incite
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("dw",12292,"buff","player") -- Death Wish
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"cs")
	table.insert(cfg.plistdps,"bt")
	table.insert(cfg.plistdps,"hs_Trance")
	table.insert(cfg.plistdps,"execute")
	table.insert(cfg.plistdps,"rb_enrage")
	table.insert(cfg.plistdps,"slam_bs")
	table.insert(cfg.plistdps,"br")
	table.insert(cfg.plistdps,"bs_single")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"cs")
	table.insert(cfg.plistaoe,"ir")
	table.insert(cfg.plistaoe,"ww")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"rb_aoe")
	table.insert(cfg.plistaoe,"bs")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["execute"] = function()
			local t,s = lib.GetAura({"Executioner"})
			if cfg.spells["execute"].isUsable==1 and (s<5 or (s==5 and t<2)) then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["rb_enrage"] = function()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t>0 then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
		["rb_aoe"] = function()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t>0 and cfg.power >= 70  then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
		["cleave"] = function()
			if lib.SpellTL("ww")>2  then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["slam_bs"] = function ()
			local t = lib.GetAura({"bs"})
			if t>0 then
				return lib.SimpleCDCheck("slam")
			end
			return nil
		end,
		["br"] = function ()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t==0 and lib.GetAura({"bs"})==0 and lib.GetAura({"Trance"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["hs_Trance"] = function ()
			local t = lib.GetAura({"Trance"})
			if t>0 or cfg.power >= 90 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["hs"] = function ()
			if cfg.power == 100 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["bs_single"] = function ()
			if cfg.power < cfg.spells["bt"].powerCost then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("strike") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonhealthupdate = function()
		if lib.UpdateSpellCD("execute") then cfg.Update=true end
	end
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	cfg.onpower=true
	return true
end

lib.classes["WARRIOR"][1] = function ()

	lib.AddSpell("strike",{88161}) -- Strike
	lib.AddSpell("Rend",{772}) -- Rend
--[[	lib.AddSpell("bt",{23881}) -- Bloodthirst
	lib.AddSpell("rb",{85288}) -- Raging Blow]]
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("ms",{12294}) -- Mortal Strike
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("op",{7384}) -- Overpower
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddSpell("bs",{6673}) -- Battle Shout
	lib.AddSpell("hs",{78}) -- Heroic Strike
	
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("dw",{12292}) -- Death Wish
	
	
	lib.AddSpell("ir",{1134}) -- Inner Rage
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ww",{1680}) -- Whirlwind
	
				
	lib.AddAura("Rend",94009,"debuff","target") -- Rend
	lib.AddAura("ToB",60503,"buff","player") -- Taste for Blood
	lib.AddAura("sd",52437,"buff","player") -- Sudden Death
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"debuff","target") -- Executioner
	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	lib.AddAura("Incite",86627,"buff","player") -- Incite
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("dw",12292,"buff","player") -- Death Wish
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Rend_noRend")
	table.insert(cfg.plistdps,"cs")
	table.insert(cfg.plistdps,"ms")
	table.insert(cfg.plistdps,"op_ToB")
	table.insert(cfg.plistdps,"execute")
	table.insert(cfg.plistdps,"hs_Trance")
	table.insert(cfg.plistdps,"slam_noms")
	table.insert(cfg.plistdps,"bs_single")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"cs")
	table.insert(cfg.plistaoe,"ir")
	table.insert(cfg.plistaoe,"ww")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"rb_aoe")
	table.insert(cfg.plistaoe,"bs")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["cs"] = function()
			return lib.SimpleCDCheck("cs")
		end,
		["ms"] = function()
			return lib.SimpleCDCheck("ms")
		end,
		["op_ToB"] = function()
			local t = lib.GetAura({"ToB"})
			if t>0 then
				return lib.SimpleCDCheck("op")
			end
			return nil
		end,
		["Rend_noRend"] = function()
			local t = lib.GetAura({"Rend"})
			if t==0 then
				return lib.SimpleCDCheck("Rend")
			end
			return nil
		end,
		["execute"] = function()
			local t,s = lib.GetAura({"Executioner"})
			if cfg.spells["execute"].isUsable==1 and (s<5 or (s==5 and t<2)) then
				print(t.." "..s)
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["cleave"] = function()
			if lib.SpellTL("ww")>2  then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["slam_noms"] = function ()
			if lib.SpellTL("ms")>1.5 and cfg.power>(cfg.spells["ms"].powerCost+cfg.spells["slam"].powerCost) then
				return lib.SimpleCDCheck("slam")
			end
			return nil
		end,
		["br"] = function ()
			local t = lib.GetAura({"Enrage","dw","br"})
			if t==0 and lib.GetAura({"bs"})==0 and lib.GetAura({"Trance"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["hs_Trance"] = function ()
			local t = lib.GetAura({"Trance"})
			if t>0 or cfg.power >= 90 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["hs"] = function ()
			if cfg.power == 100 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["bs_single"] = function ()
			if cfg.power < cfg.spells["ms"].powerCost then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("strike") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonhealthupdate = function()
		if lib.UpdateSpellCD("execute") then cfg.Update=true end
	end
	
	cfg.mode = "dps"
	
--[[	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end]]
	
	cfg.onpower=true
	return true
end